// AUTO-GENERATED FILE DO NOT EDIT
// See src/mongo/base/generate_error_codes.py
/*    Copyright 2014 MongoDB, Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    As a special exception, the copyright holders give permission to link the
 *    code of portions of this program with the OpenSSL library under certain
 *    conditions as described in each individual source file and distribute
 *    linked combinations including the program with the OpenSSL library. You
 *    must comply with the GNU Affero General Public License in all respects
 *    for all of the code used other than as permitted herein. If you modify
 *    file(s) with this exception, you may extend this exception to your
 *    version of the file(s), but you are not obligated to do so. If you do not
 *    wish to do so, delete this exception statement from your version. If you
 *    delete this exception statement from all source files in the program,
 *    then also delete it in the license file.
 */
#include "mongo/base/error_codes.h"
#include "mongo/util/mongoutils/str.h"
namespace mongo {
    std::string ErrorCodes::errorString(Error err) {
        switch (err) {
        case OK: return "OK";
        case InternalError: return "InternalError";
        case BadValue: return "BadValue";
        case OBSOLETE_DuplicateKey: return "OBSOLETE_DuplicateKey";
        case NoSuchKey: return "NoSuchKey";
        case GraphContainsCycle: return "GraphContainsCycle";
        case HostUnreachable: return "HostUnreachable";
        case HostNotFound: return "HostNotFound";
        case UnknownError: return "UnknownError";
        case FailedToParse: return "FailedToParse";
        case CannotMutateObject: return "CannotMutateObject";
        case UserNotFound: return "UserNotFound";
        case UnsupportedFormat: return "UnsupportedFormat";
        case Unauthorized: return "Unauthorized";
        case TypeMismatch: return "TypeMismatch";
        case Overflow: return "Overflow";
        case InvalidLength: return "InvalidLength";
        case ProtocolError: return "ProtocolError";
        case AuthenticationFailed: return "AuthenticationFailed";
        case CannotReuseObject: return "CannotReuseObject";
        case IllegalOperation: return "IllegalOperation";
        case EmptyArrayOperation: return "EmptyArrayOperation";
        case InvalidBSON: return "InvalidBSON";
        case AlreadyInitialized: return "AlreadyInitialized";
        case LockTimeout: return "LockTimeout";
        case RemoteValidationError: return "RemoteValidationError";
        case NamespaceNotFound: return "NamespaceNotFound";
        case IndexNotFound: return "IndexNotFound";
        case PathNotViable: return "PathNotViable";
        case NonExistentPath: return "NonExistentPath";
        case InvalidPath: return "InvalidPath";
        case RoleNotFound: return "RoleNotFound";
        case RolesNotRelated: return "RolesNotRelated";
        case PrivilegeNotFound: return "PrivilegeNotFound";
        case CannotBackfillArray: return "CannotBackfillArray";
        case UserModificationFailed: return "UserModificationFailed";
        case RemoteChangeDetected: return "RemoteChangeDetected";
        case FileRenameFailed: return "FileRenameFailed";
        case FileNotOpen: return "FileNotOpen";
        case FileStreamFailed: return "FileStreamFailed";
        case ConflictingUpdateOperators: return "ConflictingUpdateOperators";
        case FileAlreadyOpen: return "FileAlreadyOpen";
        case LogWriteFailed: return "LogWriteFailed";
        case CursorNotFound: return "CursorNotFound";
        case UserDataInconsistent: return "UserDataInconsistent";
        case LockBusy: return "LockBusy";
        case NoMatchingDocument: return "NoMatchingDocument";
        case NamespaceExists: return "NamespaceExists";
        case InvalidRoleModification: return "InvalidRoleModification";
        case ExceededTimeLimit: return "ExceededTimeLimit";
        case ManualInterventionRequired: return "ManualInterventionRequired";
        case DollarPrefixedFieldName: return "DollarPrefixedFieldName";
        case InvalidIdField: return "InvalidIdField";
        case NotSingleValueField: return "NotSingleValueField";
        case InvalidDBRef: return "InvalidDBRef";
        case EmptyFieldName: return "EmptyFieldName";
        case DottedFieldName: return "DottedFieldName";
        case RoleModificationFailed: return "RoleModificationFailed";
        case CommandNotFound: return "CommandNotFound";
        case OBSOLETE_DatabaseNotFound: return "OBSOLETE_DatabaseNotFound";
        case ShardKeyNotFound: return "ShardKeyNotFound";
        case OplogOperationUnsupported: return "OplogOperationUnsupported";
        case StaleShardVersion: return "StaleShardVersion";
        case WriteConcernFailed: return "WriteConcernFailed";
        case MultipleErrorsOccurred: return "MultipleErrorsOccurred";
        case ImmutableField: return "ImmutableField";
        case CannotCreateIndex: return "CannotCreateIndex";
        case IndexAlreadyExists: return "IndexAlreadyExists";
        case AuthSchemaIncompatible: return "AuthSchemaIncompatible";
        case ShardNotFound: return "ShardNotFound";
        case ReplicaSetNotFound: return "ReplicaSetNotFound";
        case InvalidOptions: return "InvalidOptions";
        case InvalidNamespace: return "InvalidNamespace";
        case NodeNotFound: return "NodeNotFound";
        case WriteConcernLegacyOK: return "WriteConcernLegacyOK";
        case NoReplicationEnabled: return "NoReplicationEnabled";
        case OperationIncomplete: return "OperationIncomplete";
        case CommandResultSchemaViolation: return "CommandResultSchemaViolation";
        case UnknownReplWriteConcern: return "UnknownReplWriteConcern";
        case RoleDataInconsistent: return "RoleDataInconsistent";
        case NoMatchParseContext: return "NoMatchParseContext";
        case NoProgressMade: return "NoProgressMade";
        case RemoteResultsUnavailable: return "RemoteResultsUnavailable";
        case DuplicateKeyValue: return "DuplicateKeyValue";
        case IndexOptionsConflict: return "IndexOptionsConflict";
        case IndexKeySpecsConflict: return "IndexKeySpecsConflict";
        case CannotSplit: return "CannotSplit";
        case SplitFailed_OBSOLETE: return "SplitFailed_OBSOLETE";
        case NetworkTimeout: return "NetworkTimeout";
        case CallbackCanceled: return "CallbackCanceled";
        case ShutdownInProgress: return "ShutdownInProgress";
        case SecondaryAheadOfPrimary: return "SecondaryAheadOfPrimary";
        case InvalidReplicaSetConfig: return "InvalidReplicaSetConfig";
        case NotYetInitialized: return "NotYetInitialized";
        case NotSecondary: return "NotSecondary";
        case OperationFailed: return "OperationFailed";
        case NoProjectionFound: return "NoProjectionFound";
        case DBPathInUse: return "DBPathInUse";
        case CannotSatisfyWriteConcern: return "CannotSatisfyWriteConcern";
        case OutdatedClient: return "OutdatedClient";
        case IncompatibleAuditMetadata: return "IncompatibleAuditMetadata";
        case NewReplicaSetConfigurationIncompatible: return "NewReplicaSetConfigurationIncompatible";
        case NodeNotElectable: return "NodeNotElectable";
        case IncompatibleShardingMetadata: return "IncompatibleShardingMetadata";
        case DistributedClockSkewed: return "DistributedClockSkewed";
        case LockFailed: return "LockFailed";
        case InconsistentReplicaSetNames: return "InconsistentReplicaSetNames";
        case ConfigurationInProgress: return "ConfigurationInProgress";
        case CannotInitializeNodeWithData: return "CannotInitializeNodeWithData";
        case NotExactValueField: return "NotExactValueField";
        case WriteConflict: return "WriteConflict";
        case InitialSyncFailure: return "InitialSyncFailure";
        case InitialSyncOplogSourceMissing: return "InitialSyncOplogSourceMissing";
        case CommandNotSupported: return "CommandNotSupported";
        case DocTooLargeForCapped: return "DocTooLargeForCapped";
        case ConflictingOperationInProgress: return "ConflictingOperationInProgress";
        case NamespaceNotSharded: return "NamespaceNotSharded";
        case InvalidSyncSource: return "InvalidSyncSource";
        case OplogStartMissing: return "OplogStartMissing";
        case DocumentValidationFailure: return "DocumentValidationFailure";
        case OBSOLETE_ReadAfterOptimeTimeout: return "OBSOLETE_ReadAfterOptimeTimeout";
        case NotAReplicaSet: return "NotAReplicaSet";
        case IncompatibleElectionProtocol: return "IncompatibleElectionProtocol";
        case CommandFailed: return "CommandFailed";
        case RPCProtocolNegotiationFailed: return "RPCProtocolNegotiationFailed";
        case UnrecoverableRollbackError: return "UnrecoverableRollbackError";
        case LockNotFound: return "LockNotFound";
        case LockStateChangeFailed: return "LockStateChangeFailed";
        case SymbolNotFound: return "SymbolNotFound";
        case RLPInitializationFailed: return "RLPInitializationFailed";
        case OBSOLETE_ConfigServersInconsistent: return "OBSOLETE_ConfigServersInconsistent";
        case FailedToSatisfyReadPreference: return "FailedToSatisfyReadPreference";
        case ReadConcernMajorityNotAvailableYet: return "ReadConcernMajorityNotAvailableYet";
        case StaleTerm: return "StaleTerm";
        case CappedPositionLost: return "CappedPositionLost";
        case IncompatibleShardingConfigVersion: return "IncompatibleShardingConfigVersion";
        case RemoteOplogStale: return "RemoteOplogStale";
        case JSInterpreterFailure: return "JSInterpreterFailure";
        case InvalidSSLConfiguration: return "InvalidSSLConfiguration";
        case SSLHandshakeFailed: return "SSLHandshakeFailed";
        case JSUncatchableError: return "JSUncatchableError";
        case CursorInUse: return "CursorInUse";
        case IncompatibleCatalogManager: return "IncompatibleCatalogManager";
        case PooledConnectionsDropped: return "PooledConnectionsDropped";
        case ExceededMemoryLimit: return "ExceededMemoryLimit";
        case ZLibError: return "ZLibError";
        case ReadConcernMajorityNotEnabled: return "ReadConcernMajorityNotEnabled";
        case NoConfigMaster: return "NoConfigMaster";
        case StaleEpoch: return "StaleEpoch";
        case OperationCannotBeBatched: return "OperationCannotBeBatched";
        case OplogOutOfOrder: return "OplogOutOfOrder";
        case ChunkTooBig: return "ChunkTooBig";
        case InconsistentShardIdentity: return "InconsistentShardIdentity";
        case CannotApplyOplogWhilePrimary: return "CannotApplyOplogWhilePrimary";
        case NeedsDocumentMove: return "NeedsDocumentMove";
        case CanRepairToDowngrade: return "CanRepairToDowngrade";
        case MustUpgrade: return "MustUpgrade";
        case DurationOverflow: return "DurationOverflow";
        case MaxStalenessOutOfRange: return "MaxStalenessOutOfRange";
        case IncompatibleCollationVersion: return "IncompatibleCollationVersion";
        case CollectionIsEmpty: return "CollectionIsEmpty";
        case ZoneStillInUse: return "ZoneStillInUse";
        case InitialSyncActive: return "InitialSyncActive";
        case ViewDepthLimitExceeded: return "ViewDepthLimitExceeded";
        case CommandNotSupportedOnView: return "CommandNotSupportedOnView";
        case OptionNotSupportedOnView: return "OptionNotSupportedOnView";
        case InvalidPipelineOperator: return "InvalidPipelineOperator";
        case CommandOnShardedViewNotSupportedOnMongod: return "CommandOnShardedViewNotSupportedOnMongod";
        case TooManyMatchingDocuments: return "TooManyMatchingDocuments";
        case CannotIndexParallelArrays: return "CannotIndexParallelArrays";
        case TransportSessionClosed: return "TransportSessionClosed";
        case TransportSessionNotFound: return "TransportSessionNotFound";
        case TransportSessionUnknown: return "TransportSessionUnknown";
        case QueryPlanKilled: return "QueryPlanKilled";
        case FileOpenFailed: return "FileOpenFailed";
        case ZoneNotFound: return "ZoneNotFound";
        case RangeOverlapConflict: return "RangeOverlapConflict";
        case WindowsPdhError: return "WindowsPdhError";
        case BadPerfCounterPath: return "BadPerfCounterPath";
        case AmbiguousIndexKeyPattern: return "AmbiguousIndexKeyPattern";
        case InvalidViewDefinition: return "InvalidViewDefinition";
        case ClientMetadataMissingField: return "ClientMetadataMissingField";
        case ClientMetadataAppNameTooLarge: return "ClientMetadataAppNameTooLarge";
        case ClientMetadataDocumentTooLarge: return "ClientMetadataDocumentTooLarge";
        case ClientMetadataCannotBeMutated: return "ClientMetadataCannotBeMutated";
        case LinearizableReadConcernError: return "LinearizableReadConcernError";
        case IncompatibleServerVersion: return "IncompatibleServerVersion";
        case PrimarySteppedDown: return "PrimarySteppedDown";
        case MasterSlaveConnectionFailure: return "MasterSlaveConnectionFailure";
        case BalancerLostDistributedLock: return "BalancerLostDistributedLock";
        case FailPointEnabled: return "FailPointEnabled";
        case NoShardingEnabled: return "NoShardingEnabled";
        case BalancerInterrupted: return "BalancerInterrupted";
        case ViewPipelineMaxSizeExceeded: return "ViewPipelineMaxSizeExceeded";
        case InvalidIndexSpecificationOption: return "InvalidIndexSpecificationOption";
        case OBSOLETE_ReceivedOpReplyMessage: return "OBSOLETE_ReceivedOpReplyMessage";
        case ReplicaSetMonitorRemoved: return "ReplicaSetMonitorRemoved";
        case ChunkRangeCleanupPending: return "ChunkRangeCleanupPending";
        case CannotBuildIndexKeys: return "CannotBuildIndexKeys";
        case NetworkInterfaceExceededTimeLimit: return "NetworkInterfaceExceededTimeLimit";
        case TooManyLocks: return "TooManyLocks";
        case SocketException: return "SocketException";
        case RecvStaleConfig: return "RecvStaleConfig";
        case CannotGrowDocumentInCappedNamespace: return "CannotGrowDocumentInCappedNamespace";
        case NotMaster: return "NotMaster";
        case DuplicateKey: return "DuplicateKey";
        case InterruptedAtShutdown: return "InterruptedAtShutdown";
        case Interrupted: return "Interrupted";
        case InterruptedDueToReplStateChange: return "InterruptedDueToReplStateChange";
        case BackgroundOperationInProgressForDatabase: return "BackgroundOperationInProgressForDatabase";
        case BackgroundOperationInProgressForNamespace: return "BackgroundOperationInProgressForNamespace";
        case OBSOLETE_PrepareConfigsFailed: return "OBSOLETE_PrepareConfigsFailed";
        case DatabaseDifferCase: return "DatabaseDifferCase";
        case ShardKeyTooBig: return "ShardKeyTooBig";
        case SendStaleConfig: return "SendStaleConfig";
        case NotMasterNoSlaveOk: return "NotMasterNoSlaveOk";
        case NotMasterOrSecondary: return "NotMasterOrSecondary";
        case OutOfDiskSpace: return "OutOfDiskSpace";
        case KeyTooLong: return "KeyTooLong";
        default: return mongoutils::str::stream() << "Location" << err;
        }
    }
    ErrorCodes::Error ErrorCodes::fromString(StringData name) {
        if (name == "OK") return OK;
        if (name == "InternalError") return InternalError;
        if (name == "BadValue") return BadValue;
        if (name == "OBSOLETE_DuplicateKey") return OBSOLETE_DuplicateKey;
        if (name == "NoSuchKey") return NoSuchKey;
        if (name == "GraphContainsCycle") return GraphContainsCycle;
        if (name == "HostUnreachable") return HostUnreachable;
        if (name == "HostNotFound") return HostNotFound;
        if (name == "UnknownError") return UnknownError;
        if (name == "FailedToParse") return FailedToParse;
        if (name == "CannotMutateObject") return CannotMutateObject;
        if (name == "UserNotFound") return UserNotFound;
        if (name == "UnsupportedFormat") return UnsupportedFormat;
        if (name == "Unauthorized") return Unauthorized;
        if (name == "TypeMismatch") return TypeMismatch;
        if (name == "Overflow") return Overflow;
        if (name == "InvalidLength") return InvalidLength;
        if (name == "ProtocolError") return ProtocolError;
        if (name == "AuthenticationFailed") return AuthenticationFailed;
        if (name == "CannotReuseObject") return CannotReuseObject;
        if (name == "IllegalOperation") return IllegalOperation;
        if (name == "EmptyArrayOperation") return EmptyArrayOperation;
        if (name == "InvalidBSON") return InvalidBSON;
        if (name == "AlreadyInitialized") return AlreadyInitialized;
        if (name == "LockTimeout") return LockTimeout;
        if (name == "RemoteValidationError") return RemoteValidationError;
        if (name == "NamespaceNotFound") return NamespaceNotFound;
        if (name == "IndexNotFound") return IndexNotFound;
        if (name == "PathNotViable") return PathNotViable;
        if (name == "NonExistentPath") return NonExistentPath;
        if (name == "InvalidPath") return InvalidPath;
        if (name == "RoleNotFound") return RoleNotFound;
        if (name == "RolesNotRelated") return RolesNotRelated;
        if (name == "PrivilegeNotFound") return PrivilegeNotFound;
        if (name == "CannotBackfillArray") return CannotBackfillArray;
        if (name == "UserModificationFailed") return UserModificationFailed;
        if (name == "RemoteChangeDetected") return RemoteChangeDetected;
        if (name == "FileRenameFailed") return FileRenameFailed;
        if (name == "FileNotOpen") return FileNotOpen;
        if (name == "FileStreamFailed") return FileStreamFailed;
        if (name == "ConflictingUpdateOperators") return ConflictingUpdateOperators;
        if (name == "FileAlreadyOpen") return FileAlreadyOpen;
        if (name == "LogWriteFailed") return LogWriteFailed;
        if (name == "CursorNotFound") return CursorNotFound;
        if (name == "UserDataInconsistent") return UserDataInconsistent;
        if (name == "LockBusy") return LockBusy;
        if (name == "NoMatchingDocument") return NoMatchingDocument;
        if (name == "NamespaceExists") return NamespaceExists;
        if (name == "InvalidRoleModification") return InvalidRoleModification;
        if (name == "ExceededTimeLimit") return ExceededTimeLimit;
        if (name == "ManualInterventionRequired") return ManualInterventionRequired;
        if (name == "DollarPrefixedFieldName") return DollarPrefixedFieldName;
        if (name == "InvalidIdField") return InvalidIdField;
        if (name == "NotSingleValueField") return NotSingleValueField;
        if (name == "InvalidDBRef") return InvalidDBRef;
        if (name == "EmptyFieldName") return EmptyFieldName;
        if (name == "DottedFieldName") return DottedFieldName;
        if (name == "RoleModificationFailed") return RoleModificationFailed;
        if (name == "CommandNotFound") return CommandNotFound;
        if (name == "OBSOLETE_DatabaseNotFound") return OBSOLETE_DatabaseNotFound;
        if (name == "ShardKeyNotFound") return ShardKeyNotFound;
        if (name == "OplogOperationUnsupported") return OplogOperationUnsupported;
        if (name == "StaleShardVersion") return StaleShardVersion;
        if (name == "WriteConcernFailed") return WriteConcernFailed;
        if (name == "MultipleErrorsOccurred") return MultipleErrorsOccurred;
        if (name == "ImmutableField") return ImmutableField;
        if (name == "CannotCreateIndex") return CannotCreateIndex;
        if (name == "IndexAlreadyExists") return IndexAlreadyExists;
        if (name == "AuthSchemaIncompatible") return AuthSchemaIncompatible;
        if (name == "ShardNotFound") return ShardNotFound;
        if (name == "ReplicaSetNotFound") return ReplicaSetNotFound;
        if (name == "InvalidOptions") return InvalidOptions;
        if (name == "InvalidNamespace") return InvalidNamespace;
        if (name == "NodeNotFound") return NodeNotFound;
        if (name == "WriteConcernLegacyOK") return WriteConcernLegacyOK;
        if (name == "NoReplicationEnabled") return NoReplicationEnabled;
        if (name == "OperationIncomplete") return OperationIncomplete;
        if (name == "CommandResultSchemaViolation") return CommandResultSchemaViolation;
        if (name == "UnknownReplWriteConcern") return UnknownReplWriteConcern;
        if (name == "RoleDataInconsistent") return RoleDataInconsistent;
        if (name == "NoMatchParseContext") return NoMatchParseContext;
        if (name == "NoProgressMade") return NoProgressMade;
        if (name == "RemoteResultsUnavailable") return RemoteResultsUnavailable;
        if (name == "DuplicateKeyValue") return DuplicateKeyValue;
        if (name == "IndexOptionsConflict") return IndexOptionsConflict;
        if (name == "IndexKeySpecsConflict") return IndexKeySpecsConflict;
        if (name == "CannotSplit") return CannotSplit;
        if (name == "SplitFailed_OBSOLETE") return SplitFailed_OBSOLETE;
        if (name == "NetworkTimeout") return NetworkTimeout;
        if (name == "CallbackCanceled") return CallbackCanceled;
        if (name == "ShutdownInProgress") return ShutdownInProgress;
        if (name == "SecondaryAheadOfPrimary") return SecondaryAheadOfPrimary;
        if (name == "InvalidReplicaSetConfig") return InvalidReplicaSetConfig;
        if (name == "NotYetInitialized") return NotYetInitialized;
        if (name == "NotSecondary") return NotSecondary;
        if (name == "OperationFailed") return OperationFailed;
        if (name == "NoProjectionFound") return NoProjectionFound;
        if (name == "DBPathInUse") return DBPathInUse;
        if (name == "CannotSatisfyWriteConcern") return CannotSatisfyWriteConcern;
        if (name == "OutdatedClient") return OutdatedClient;
        if (name == "IncompatibleAuditMetadata") return IncompatibleAuditMetadata;
        if (name == "NewReplicaSetConfigurationIncompatible") return NewReplicaSetConfigurationIncompatible;
        if (name == "NodeNotElectable") return NodeNotElectable;
        if (name == "IncompatibleShardingMetadata") return IncompatibleShardingMetadata;
        if (name == "DistributedClockSkewed") return DistributedClockSkewed;
        if (name == "LockFailed") return LockFailed;
        if (name == "InconsistentReplicaSetNames") return InconsistentReplicaSetNames;
        if (name == "ConfigurationInProgress") return ConfigurationInProgress;
        if (name == "CannotInitializeNodeWithData") return CannotInitializeNodeWithData;
        if (name == "NotExactValueField") return NotExactValueField;
        if (name == "WriteConflict") return WriteConflict;
        if (name == "InitialSyncFailure") return InitialSyncFailure;
        if (name == "InitialSyncOplogSourceMissing") return InitialSyncOplogSourceMissing;
        if (name == "CommandNotSupported") return CommandNotSupported;
        if (name == "DocTooLargeForCapped") return DocTooLargeForCapped;
        if (name == "ConflictingOperationInProgress") return ConflictingOperationInProgress;
        if (name == "NamespaceNotSharded") return NamespaceNotSharded;
        if (name == "InvalidSyncSource") return InvalidSyncSource;
        if (name == "OplogStartMissing") return OplogStartMissing;
        if (name == "DocumentValidationFailure") return DocumentValidationFailure;
        if (name == "OBSOLETE_ReadAfterOptimeTimeout") return OBSOLETE_ReadAfterOptimeTimeout;
        if (name == "NotAReplicaSet") return NotAReplicaSet;
        if (name == "IncompatibleElectionProtocol") return IncompatibleElectionProtocol;
        if (name == "CommandFailed") return CommandFailed;
        if (name == "RPCProtocolNegotiationFailed") return RPCProtocolNegotiationFailed;
        if (name == "UnrecoverableRollbackError") return UnrecoverableRollbackError;
        if (name == "LockNotFound") return LockNotFound;
        if (name == "LockStateChangeFailed") return LockStateChangeFailed;
        if (name == "SymbolNotFound") return SymbolNotFound;
        if (name == "RLPInitializationFailed") return RLPInitializationFailed;
        if (name == "OBSOLETE_ConfigServersInconsistent") return OBSOLETE_ConfigServersInconsistent;
        if (name == "FailedToSatisfyReadPreference") return FailedToSatisfyReadPreference;
        if (name == "ReadConcernMajorityNotAvailableYet") return ReadConcernMajorityNotAvailableYet;
        if (name == "StaleTerm") return StaleTerm;
        if (name == "CappedPositionLost") return CappedPositionLost;
        if (name == "IncompatibleShardingConfigVersion") return IncompatibleShardingConfigVersion;
        if (name == "RemoteOplogStale") return RemoteOplogStale;
        if (name == "JSInterpreterFailure") return JSInterpreterFailure;
        if (name == "InvalidSSLConfiguration") return InvalidSSLConfiguration;
        if (name == "SSLHandshakeFailed") return SSLHandshakeFailed;
        if (name == "JSUncatchableError") return JSUncatchableError;
        if (name == "CursorInUse") return CursorInUse;
        if (name == "IncompatibleCatalogManager") return IncompatibleCatalogManager;
        if (name == "PooledConnectionsDropped") return PooledConnectionsDropped;
        if (name == "ExceededMemoryLimit") return ExceededMemoryLimit;
        if (name == "ZLibError") return ZLibError;
        if (name == "ReadConcernMajorityNotEnabled") return ReadConcernMajorityNotEnabled;
        if (name == "NoConfigMaster") return NoConfigMaster;
        if (name == "StaleEpoch") return StaleEpoch;
        if (name == "OperationCannotBeBatched") return OperationCannotBeBatched;
        if (name == "OplogOutOfOrder") return OplogOutOfOrder;
        if (name == "ChunkTooBig") return ChunkTooBig;
        if (name == "InconsistentShardIdentity") return InconsistentShardIdentity;
        if (name == "CannotApplyOplogWhilePrimary") return CannotApplyOplogWhilePrimary;
        if (name == "NeedsDocumentMove") return NeedsDocumentMove;
        if (name == "CanRepairToDowngrade") return CanRepairToDowngrade;
        if (name == "MustUpgrade") return MustUpgrade;
        if (name == "DurationOverflow") return DurationOverflow;
        if (name == "MaxStalenessOutOfRange") return MaxStalenessOutOfRange;
        if (name == "IncompatibleCollationVersion") return IncompatibleCollationVersion;
        if (name == "CollectionIsEmpty") return CollectionIsEmpty;
        if (name == "ZoneStillInUse") return ZoneStillInUse;
        if (name == "InitialSyncActive") return InitialSyncActive;
        if (name == "ViewDepthLimitExceeded") return ViewDepthLimitExceeded;
        if (name == "CommandNotSupportedOnView") return CommandNotSupportedOnView;
        if (name == "OptionNotSupportedOnView") return OptionNotSupportedOnView;
        if (name == "InvalidPipelineOperator") return InvalidPipelineOperator;
        if (name == "CommandOnShardedViewNotSupportedOnMongod") return CommandOnShardedViewNotSupportedOnMongod;
        if (name == "TooManyMatchingDocuments") return TooManyMatchingDocuments;
        if (name == "CannotIndexParallelArrays") return CannotIndexParallelArrays;
        if (name == "TransportSessionClosed") return TransportSessionClosed;
        if (name == "TransportSessionNotFound") return TransportSessionNotFound;
        if (name == "TransportSessionUnknown") return TransportSessionUnknown;
        if (name == "QueryPlanKilled") return QueryPlanKilled;
        if (name == "FileOpenFailed") return FileOpenFailed;
        if (name == "ZoneNotFound") return ZoneNotFound;
        if (name == "RangeOverlapConflict") return RangeOverlapConflict;
        if (name == "WindowsPdhError") return WindowsPdhError;
        if (name == "BadPerfCounterPath") return BadPerfCounterPath;
        if (name == "AmbiguousIndexKeyPattern") return AmbiguousIndexKeyPattern;
        if (name == "InvalidViewDefinition") return InvalidViewDefinition;
        if (name == "ClientMetadataMissingField") return ClientMetadataMissingField;
        if (name == "ClientMetadataAppNameTooLarge") return ClientMetadataAppNameTooLarge;
        if (name == "ClientMetadataDocumentTooLarge") return ClientMetadataDocumentTooLarge;
        if (name == "ClientMetadataCannotBeMutated") return ClientMetadataCannotBeMutated;
        if (name == "LinearizableReadConcernError") return LinearizableReadConcernError;
        if (name == "IncompatibleServerVersion") return IncompatibleServerVersion;
        if (name == "PrimarySteppedDown") return PrimarySteppedDown;
        if (name == "MasterSlaveConnectionFailure") return MasterSlaveConnectionFailure;
        if (name == "BalancerLostDistributedLock") return BalancerLostDistributedLock;
        if (name == "FailPointEnabled") return FailPointEnabled;
        if (name == "NoShardingEnabled") return NoShardingEnabled;
        if (name == "BalancerInterrupted") return BalancerInterrupted;
        if (name == "ViewPipelineMaxSizeExceeded") return ViewPipelineMaxSizeExceeded;
        if (name == "InvalidIndexSpecificationOption") return InvalidIndexSpecificationOption;
        if (name == "OBSOLETE_ReceivedOpReplyMessage") return OBSOLETE_ReceivedOpReplyMessage;
        if (name == "ReplicaSetMonitorRemoved") return ReplicaSetMonitorRemoved;
        if (name == "ChunkRangeCleanupPending") return ChunkRangeCleanupPending;
        if (name == "CannotBuildIndexKeys") return CannotBuildIndexKeys;
        if (name == "NetworkInterfaceExceededTimeLimit") return NetworkInterfaceExceededTimeLimit;
        if (name == "TooManyLocks") return TooManyLocks;
        if (name == "SocketException") return SocketException;
        if (name == "RecvStaleConfig") return RecvStaleConfig;
        if (name == "CannotGrowDocumentInCappedNamespace") return CannotGrowDocumentInCappedNamespace;
        if (name == "NotMaster") return NotMaster;
        if (name == "DuplicateKey") return DuplicateKey;
        if (name == "InterruptedAtShutdown") return InterruptedAtShutdown;
        if (name == "Interrupted") return Interrupted;
        if (name == "InterruptedDueToReplStateChange") return InterruptedDueToReplStateChange;
        if (name == "BackgroundOperationInProgressForDatabase") return BackgroundOperationInProgressForDatabase;
        if (name == "BackgroundOperationInProgressForNamespace") return BackgroundOperationInProgressForNamespace;
        if (name == "OBSOLETE_PrepareConfigsFailed") return OBSOLETE_PrepareConfigsFailed;
        if (name == "DatabaseDifferCase") return DatabaseDifferCase;
        if (name == "ShardKeyTooBig") return ShardKeyTooBig;
        if (name == "SendStaleConfig") return SendStaleConfig;
        if (name == "NotMasterNoSlaveOk") return NotMasterNoSlaveOk;
        if (name == "NotMasterOrSecondary") return NotMasterOrSecondary;
        if (name == "OutOfDiskSpace") return OutOfDiskSpace;
        if (name == "KeyTooLong") return KeyTooLong;
        return UnknownError;
    }
    ErrorCodes::Error ErrorCodes::fromInt(int code) {
        return static_cast<Error>(code);
    }
    bool ErrorCodes::isNetworkError(Error err) {
        switch (err) {
        case HostUnreachable:
        case HostNotFound:
        case NetworkTimeout:
            return true;
        default:
            return false;
        }
    }

    bool ErrorCodes::isInterruption(Error err) {
        switch (err) {
        case Interrupted:
        case InterruptedAtShutdown:
        case InterruptedDueToReplStateChange:
        case ExceededTimeLimit:
            return true;
        default:
            return false;
        }
    }

    bool ErrorCodes::isNotMasterError(Error err) {
        switch (err) {
        case NotMaster:
        case NotMasterNoSlaveOk:
            return true;
        default:
            return false;
        }
    }

    bool ErrorCodes::isStaleShardingError(Error err) {
        switch (err) {
        case RecvStaleConfig:
        case SendStaleConfig:
        case StaleShardVersion:
        case StaleEpoch:
            return true;
        default:
            return false;
        }
    }

    bool ErrorCodes::isWriteConcernError(Error err) {
        switch (err) {
        case WriteConcernFailed:
        case WriteConcernLegacyOK:
        case UnknownReplWriteConcern:
        case CannotSatisfyWriteConcern:
            return true;
        default:
            return false;
        }
    }

    bool ErrorCodes::isShutdownError(Error err) {
        switch (err) {
        case ShutdownInProgress:
        case InterruptedAtShutdown:
            return true;
        default:
            return false;
        }
    }

namespace {
    static_assert(sizeof(ErrorCodes::Error) == sizeof(int), "sizeof(ErrorCodes::Error) == sizeof(int)");
}  // namespace
}  // namespace mongo
