// AUTO-GENERATED FILE DO NOT EDIT
// See src/mongo/base/generate_error_codes.py
/*    Copyright 2014 MongoDB, Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    As a special exception, the copyright holders give permission to link the
 *    code of portions of this program with the OpenSSL library under certain
 *    conditions as described in each individual source file and distribute
 *    linked combinations including the program with the OpenSSL library. You
 *    must comply with the GNU Affero General Public License in all respects
 *    for all of the code used other than as permitted herein. If you modify
 *    file(s) with this exception, you may extend this exception to your
 *    version of the file(s), but you are not obligated to do so. If you do not
 *    wish to do so, delete this exception statement from your version. If you
 *    delete this exception statement from all source files in the program,
 *    then also delete it in the license file.
 */
#pragma once
#include <string>
#include <cstdint>
#include "mongo/base/string_data.h"
namespace mongo {
    /**
     * This is a generated class containing a table of error codes and their corresponding error
     * strings. The class is derived from the definitions in src/mongo/base/error_codes.err file.
     *
     * Do not update this file directly. Update src/mongo/base/error_codes.err instead.
     */
    class ErrorCodes {
    public:
        // Explicitly 32-bits wide so that non-symbolic values,
        // like uassert codes, are valid.
        enum Error : std::int32_t {
            OK = 0,
            InternalError = 1,
            BadValue = 2,
            OBSOLETE_DuplicateKey = 3,
            NoSuchKey = 4,
            GraphContainsCycle = 5,
            HostUnreachable = 6,
            HostNotFound = 7,
            UnknownError = 8,
            FailedToParse = 9,
            CannotMutateObject = 10,
            UserNotFound = 11,
            UnsupportedFormat = 12,
            Unauthorized = 13,
            TypeMismatch = 14,
            Overflow = 15,
            InvalidLength = 16,
            ProtocolError = 17,
            AuthenticationFailed = 18,
            CannotReuseObject = 19,
            IllegalOperation = 20,
            EmptyArrayOperation = 21,
            InvalidBSON = 22,
            AlreadyInitialized = 23,
            LockTimeout = 24,
            RemoteValidationError = 25,
            NamespaceNotFound = 26,
            IndexNotFound = 27,
            PathNotViable = 28,
            NonExistentPath = 29,
            InvalidPath = 30,
            RoleNotFound = 31,
            RolesNotRelated = 32,
            PrivilegeNotFound = 33,
            CannotBackfillArray = 34,
            UserModificationFailed = 35,
            RemoteChangeDetected = 36,
            FileRenameFailed = 37,
            FileNotOpen = 38,
            FileStreamFailed = 39,
            ConflictingUpdateOperators = 40,
            FileAlreadyOpen = 41,
            LogWriteFailed = 42,
            CursorNotFound = 43,
            UserDataInconsistent = 45,
            LockBusy = 46,
            NoMatchingDocument = 47,
            NamespaceExists = 48,
            InvalidRoleModification = 49,
            ExceededTimeLimit = 50,
            ManualInterventionRequired = 51,
            DollarPrefixedFieldName = 52,
            InvalidIdField = 53,
            NotSingleValueField = 54,
            InvalidDBRef = 55,
            EmptyFieldName = 56,
            DottedFieldName = 57,
            RoleModificationFailed = 58,
            CommandNotFound = 59,
            OBSOLETE_DatabaseNotFound = 60,
            ShardKeyNotFound = 61,
            OplogOperationUnsupported = 62,
            StaleShardVersion = 63,
            WriteConcernFailed = 64,
            MultipleErrorsOccurred = 65,
            ImmutableField = 66,
            CannotCreateIndex = 67,
            IndexAlreadyExists = 68,
            AuthSchemaIncompatible = 69,
            ShardNotFound = 70,
            ReplicaSetNotFound = 71,
            InvalidOptions = 72,
            InvalidNamespace = 73,
            NodeNotFound = 74,
            WriteConcernLegacyOK = 75,
            NoReplicationEnabled = 76,
            OperationIncomplete = 77,
            CommandResultSchemaViolation = 78,
            UnknownReplWriteConcern = 79,
            RoleDataInconsistent = 80,
            NoMatchParseContext = 81,
            NoProgressMade = 82,
            RemoteResultsUnavailable = 83,
            DuplicateKeyValue = 84,
            IndexOptionsConflict = 85,
            IndexKeySpecsConflict = 86,
            CannotSplit = 87,
            SplitFailed_OBSOLETE = 88,
            NetworkTimeout = 89,
            CallbackCanceled = 90,
            ShutdownInProgress = 91,
            SecondaryAheadOfPrimary = 92,
            InvalidReplicaSetConfig = 93,
            NotYetInitialized = 94,
            NotSecondary = 95,
            OperationFailed = 96,
            NoProjectionFound = 97,
            DBPathInUse = 98,
            CannotSatisfyWriteConcern = 100,
            OutdatedClient = 101,
            IncompatibleAuditMetadata = 102,
            NewReplicaSetConfigurationIncompatible = 103,
            NodeNotElectable = 104,
            IncompatibleShardingMetadata = 105,
            DistributedClockSkewed = 106,
            LockFailed = 107,
            InconsistentReplicaSetNames = 108,
            ConfigurationInProgress = 109,
            CannotInitializeNodeWithData = 110,
            NotExactValueField = 111,
            WriteConflict = 112,
            InitialSyncFailure = 113,
            InitialSyncOplogSourceMissing = 114,
            CommandNotSupported = 115,
            DocTooLargeForCapped = 116,
            ConflictingOperationInProgress = 117,
            NamespaceNotSharded = 118,
            InvalidSyncSource = 119,
            OplogStartMissing = 120,
            DocumentValidationFailure = 121,
            OBSOLETE_ReadAfterOptimeTimeout = 122,
            NotAReplicaSet = 123,
            IncompatibleElectionProtocol = 124,
            CommandFailed = 125,
            RPCProtocolNegotiationFailed = 126,
            UnrecoverableRollbackError = 127,
            LockNotFound = 128,
            LockStateChangeFailed = 129,
            SymbolNotFound = 130,
            RLPInitializationFailed = 131,
            OBSOLETE_ConfigServersInconsistent = 132,
            FailedToSatisfyReadPreference = 133,
            ReadConcernMajorityNotAvailableYet = 134,
            StaleTerm = 135,
            CappedPositionLost = 136,
            IncompatibleShardingConfigVersion = 137,
            RemoteOplogStale = 138,
            JSInterpreterFailure = 139,
            InvalidSSLConfiguration = 140,
            SSLHandshakeFailed = 141,
            JSUncatchableError = 142,
            CursorInUse = 143,
            IncompatibleCatalogManager = 144,
            PooledConnectionsDropped = 145,
            ExceededMemoryLimit = 146,
            ZLibError = 147,
            ReadConcernMajorityNotEnabled = 148,
            NoConfigMaster = 149,
            StaleEpoch = 150,
            OperationCannotBeBatched = 151,
            OplogOutOfOrder = 152,
            ChunkTooBig = 153,
            InconsistentShardIdentity = 154,
            CannotApplyOplogWhilePrimary = 155,
            NeedsDocumentMove = 156,
            CanRepairToDowngrade = 157,
            MustUpgrade = 158,
            DurationOverflow = 159,
            MaxStalenessOutOfRange = 160,
            IncompatibleCollationVersion = 161,
            CollectionIsEmpty = 162,
            ZoneStillInUse = 163,
            InitialSyncActive = 164,
            ViewDepthLimitExceeded = 165,
            CommandNotSupportedOnView = 166,
            OptionNotSupportedOnView = 167,
            InvalidPipelineOperator = 168,
            CommandOnShardedViewNotSupportedOnMongod = 169,
            TooManyMatchingDocuments = 170,
            CannotIndexParallelArrays = 171,
            TransportSessionClosed = 172,
            TransportSessionNotFound = 173,
            TransportSessionUnknown = 174,
            QueryPlanKilled = 175,
            FileOpenFailed = 176,
            ZoneNotFound = 177,
            RangeOverlapConflict = 178,
            WindowsPdhError = 179,
            BadPerfCounterPath = 180,
            AmbiguousIndexKeyPattern = 181,
            InvalidViewDefinition = 182,
            ClientMetadataMissingField = 183,
            ClientMetadataAppNameTooLarge = 184,
            ClientMetadataDocumentTooLarge = 185,
            ClientMetadataCannotBeMutated = 186,
            LinearizableReadConcernError = 187,
            IncompatibleServerVersion = 188,
            PrimarySteppedDown = 189,
            MasterSlaveConnectionFailure = 190,
            BalancerLostDistributedLock = 191,
            FailPointEnabled = 192,
            NoShardingEnabled = 193,
            BalancerInterrupted = 194,
            ViewPipelineMaxSizeExceeded = 195,
            InvalidIndexSpecificationOption = 197,
            OBSOLETE_ReceivedOpReplyMessage = 198,
            ReplicaSetMonitorRemoved = 199,
            ChunkRangeCleanupPending = 200,
            CannotBuildIndexKeys = 201,
            NetworkInterfaceExceededTimeLimit = 202,
            TooManyLocks = 208,
            SocketException = 9001,
            RecvStaleConfig = 9996,
            CannotGrowDocumentInCappedNamespace = 10003,
            NotMaster = 10107,
            DuplicateKey = 11000,
            InterruptedAtShutdown = 11600,
            Interrupted = 11601,
            InterruptedDueToReplStateChange = 11602,
            BackgroundOperationInProgressForDatabase = 12586,
            BackgroundOperationInProgressForNamespace = 12587,
            OBSOLETE_PrepareConfigsFailed = 13104,
            DatabaseDifferCase = 13297,
            ShardKeyTooBig = 13334,
            SendStaleConfig = 13388,
            NotMasterNoSlaveOk = 13435,
            NotMasterOrSecondary = 13436,
            OutOfDiskSpace = 14031,
            KeyTooLong = 17280,
            MaxError
        };
        static std::string errorString(Error err);
        /**
         * Parses an Error from its "name".  Returns UnknownError if "name" is unrecognized.
         *
         * NOTE: Also returns UnknownError for the string "UnknownError".
         */
        static Error fromString(StringData name);
        /**
         * Casts an integer "code" to an Error.  Unrecognized codes are preserved, meaning
         * that the result of a call to fromInt() may not be one of the values in the
         * Error enumeration.
         */
        static Error fromInt(int code);
        static bool isNetworkError(Error err);
        static bool isInterruption(Error err);
        static bool isNotMasterError(Error err);
        static bool isStaleShardingError(Error err);
        static bool isWriteConcernError(Error err);
        static bool isShutdownError(Error err);
    };
}  // namespace mongo
